Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/ExhaustiveMCVTripleMoveGenerator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/ExhaustiveMCVTripleMoveGenerator.cs	(revision 9473)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/ExhaustiveMCVTripleMoveGenerator.cs	(revision 9473)
@@ -0,0 +1,82 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Optimization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.PackingEncoding.MultiComponentVector {
+  [Item("Exhaustive MultiComponentVector Triple Move Generator", "Generates all possible multi component moves from a given multiComponentVector.")]
+  [StorableClass]
+  public class ExhaustiveMCVTripleMoveGenerator : MultiComponentVectorMoveGenerator, IExhaustiveMoveGenerator {
+    [StorableConstructor]
+    protected ExhaustiveMCVTripleMoveGenerator(bool deserializing) : base(deserializing) { }
+    protected ExhaustiveMCVTripleMoveGenerator(ExhaustiveMCVTripleMoveGenerator original, Cloner cloner) : base(original, cloner) { }
+    public ExhaustiveMCVTripleMoveGenerator() : base() { }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ExhaustiveMCVTripleMoveGenerator(this, cloner);
+    }
+
+    public static IEnumerable<MultiComponentVectorMove> GenerateMCVTripleMoves(MultiComponentVectorEncoding mcv) {
+      int nrOfBins = 0;
+      foreach (var pi in mcv.PackingInformations) {
+        if (pi.AssignedBin > nrOfBins)
+          nrOfBins = pi.AssignedBin;
+      }
+      nrOfBins++;
+      Dictionary<int, List<int>> indexesPerBin = new Dictionary<int, List<int>>();
+      for (int i = 0; i < mcv.PackingInformations.Count; i++) {
+        int currentBin = mcv.PackingInformations[i].AssignedBin;
+        if (!indexesPerBin.ContainsKey(currentBin))
+          indexesPerBin[currentBin] = new List<int>();
+        indexesPerBin[currentBin].Add(i);
+      }
+                                                        
+      for (int index = 0; index < mcv.PackingInformations.Count; index++) { 
+        for (int group = 0; group < nrOfBins; group++) {
+          foreach (int targetIndex in indexesPerBin[group]) {
+            yield return new MCVTripleMove(index, false, group, targetIndex, mcv);
+            yield return new MCVTripleMove(index, true, group, targetIndex, mcv);
+          }
+        }
+      }
+    }
+
+    public static MultiComponentVectorMove[] Apply(MultiComponentVectorEncoding multiComponentVector) {
+      var generatedMoves = new List<MultiComponentVectorMove>(GenerateMCVTripleMoves(multiComponentVector));
+      int totalMoves = generatedMoves.Count;
+      MultiComponentVectorMove[] moves = new MultiComponentVectorMove[totalMoves];
+      int count = 0;
+      foreach (MultiComponentVectorMove move in generatedMoves) {
+        moves[count++] = move;
+      }
+      return moves;
+    }  
+
+    protected override MultiComponentVectorMove[] GenerateMoves(MultiComponentVectorEncoding multiComponentVector) {
+      return Apply(multiComponentVector);
+    }
+  }
+}
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/ExhaustiveMultiComponentVectorMoveGenerator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/ExhaustiveMultiComponentVectorMoveGenerator.cs	(revision 9472)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/ExhaustiveMultiComponentVectorMoveGenerator.cs	(revision 9473)
@@ -40,31 +40,14 @@
     }
 
-
     public static MultiComponentVectorMove[] Apply(MultiComponentVectorEncoding multiComponentVector) {
-      //NrOfMoves = nrOfRotationMoves + nrOfSingleGroupingMoves + nrOfSwapSequenceMoves
+      //NrOfMoves = nrOfRotationMoves + nrOfSingleGroupingMoves + nrOfSwapPositionMoves
       //  nrOfRotationMoves       = nrOfItems
       //  nrOfSingleGroupingMoves = nrOfItems * (nrOfBins - 1)
-      //  nrOfSwapSequenceMoves   = SUM(foreach binNr: !nrOfItemsInBin)
-
-      int lastBinNr = 0;
-      foreach (var pi in multiComponentVector.PackingInformations) {
-        if (pi.AssignedBin > lastBinNr)
-          lastBinNr = pi.AssignedBin;
-      }
-      int nrOfBins = lastBinNr + 1;
-
-      int nrOfRotationMoves = multiComponentVector.PackingInformations.Count;
-      int nrOfSingleGroupingMoves = nrOfRotationMoves * (nrOfBins - 1);
-
-      int[] itemsPerBin = new int[nrOfBins];
-      foreach (var pi in multiComponentVector.PackingInformations) {
-        itemsPerBin[pi.AssignedBin]++;
-      }
-      int nrOfSwapSequenceMoves = 0;
-      foreach (int items in itemsPerBin) {
-        nrOfSwapSequenceMoves += (items * (items - 1)) / 2;
-      }
-
-      int totalMoves = nrOfRotationMoves + nrOfSingleGroupingMoves + nrOfSwapSequenceMoves;
+      //  nrOfSwapPositionMoves   = SUM(foreach binNr: !nrOfItemsInBin)
+      int totalMoves = 
+        NrOfRotationMoves(multiComponentVector) +
+        NrOfSingleGroupingMoves(multiComponentVector) +
+        NrOfSwapPositionMoves(multiComponentVector) +
+        NrOfChangePositionMoves(multiComponentVector);
       MultiComponentVectorMove[] moves = new MultiComponentVectorMove[totalMoves];
       int count = 0;
@@ -75,9 +58,12 @@
         moves[count++] = move;
       }
-      foreach (MultiComponentVectorMove move in GenerateSwapSequenceMoves(multiComponentVector)) {
+      foreach (MultiComponentVectorMove move in GenerateSwapPositionMoves(multiComponentVector)) {
+        moves[count++] = move;
+      }
+      foreach (MultiComponentVectorMove move in GenerateChangePositionMoves(multiComponentVector)) {
         moves[count++] = move;
       }
       return moves;
-    }    
+    }  
 
     protected override MultiComponentVectorMove[] GenerateMoves(MultiComponentVectorEncoding multiComponentVector) {
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/ChangePositionMove.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/ChangePositionMove.cs	(revision 9473)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/ChangePositionMove.cs	(revision 9473)
@@ -0,0 +1,72 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.PackingEncoding.MultiComponentVector;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.PackingEncoding.MultiComponentVector {
+  [Item("ChangePositionMove", "A move on a multi component vector that is specified by two indexes. The packing informations at the first index is inserted at the second one.")]
+  [StorableClass]
+  public class ChangePositionMove : MultiComponentVectorMove {
+    [Storable]
+    public int Index { get; protected set; }
+    [Storable]
+    public int TargetIndex { get; protected set; }
+
+    [StorableConstructor]
+    protected ChangePositionMove(bool deserializing) : base(deserializing) { }
+    protected ChangePositionMove(ChangePositionMove original, Cloner cloner)
+      : base(original, cloner) {
+      this.Index = original.Index;
+      this.TargetIndex = original.TargetIndex;
+    }
+    public ChangePositionMove(int index, int targetIndex, MultiComponentVectorEncoding multiComponentVector)
+      : base(multiComponentVector) {
+        Index = index;
+        TargetIndex = targetIndex;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new ChangePositionMove(this, cloner);
+    }
+
+    public override MultiComponentVectorEncoding GetVectorAfterMove() {
+      return GetVectorAfterMove(MultiComponentVector, Index, TargetIndex);
+    }
+    public static MultiComponentVectorEncoding GetVectorAfterMove(MultiComponentVectorEncoding multiComponentVector, int index, int targetIndex) {
+      var result = multiComponentVector.Clone(new Cloner()) as MultiComponentVectorEncoding;
+      var aux = result.PackingInformations[index];
+      result.PackingInformations.RemoveAt(index);
+      result.PackingInformations.Insert(targetIndex, aux);
+      return result;
+    }
+
+    public override System.Type GetMoveAttributeType() {
+      return typeof(ChangePositionMoveAttribute);
+    }
+
+    public override string ToString() {
+      return "PM(i=" + Index + ",ti=" + TargetIndex + ")";
+    }
+  }
+}
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/MCVTripleMove.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/MCVTripleMove.cs	(revision 9473)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/MCVTripleMove.cs	(revision 9473)
@@ -0,0 +1,80 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.PackingEncoding.MultiComponentVector;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.PackingEncoding.MultiComponentVector {
+  [Item("MCVTripleMove", "A move on a multi component vector that is specified by a rotation-value, two indexes and a groupNr.")]
+  [StorableClass]
+  public class MCVTripleMove : MultiComponentVectorMove {
+    [Storable]
+    public int Index { get; protected set; }
+    [Storable]
+    public bool Rotation { get; protected set; }
+    [Storable]
+    public int Group { get; protected set; }
+    [Storable]
+    public int TargetIndex { get; protected set; }
+
+    [StorableConstructor]
+    protected MCVTripleMove(bool deserializing) : base(deserializing) { }
+    protected MCVTripleMove(MCVTripleMove original, Cloner cloner)
+      : base(original, cloner) {
+      this.Index = original.Index;
+      this.Rotation = original.Rotation;
+      this.Group = original.Group;
+      this.TargetIndex = original.TargetIndex;
+    }
+    public MCVTripleMove(int index, bool rotation, int group, int targetIndex, MultiComponentVectorEncoding multiComponentVector)
+      : base(multiComponentVector) {
+        Index = index;
+        Rotation = rotation;
+        Group = group;
+        TargetIndex = targetIndex;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new MCVTripleMove(this, cloner);
+    }
+
+    public override MultiComponentVectorEncoding GetVectorAfterMove() {
+      var result = MultiComponentVector;
+      if (Rotation)
+        result = SingleItemRotationMove.GetVectorAfterMove(MultiComponentVector, Index);
+      if (!MultiComponentVector.PackingInformations[Index].AssignedBin.Equals(Group))
+        result = SingleGroupingMove.GetVectorAfterMove(result, Index, Group);
+      if (!Index.Equals(TargetIndex))
+        result = ChangePositionMove.GetVectorAfterMove(result, Index, TargetIndex);
+      return result;
+    }
+
+    public override System.Type GetMoveAttributeType() {
+      return typeof(MCVTripleMoveAttribute);
+    }
+
+    public override string ToString() {
+      return "TM(i=" + Index + ",r=" + Rotation + ",g=" + Group + ",ti=" + TargetIndex + ")";
+    }
+  }
+}
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/SingleGroupingMove.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/SingleGroupingMove.cs	(revision 9472)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/SingleGroupingMove.cs	(revision 9473)
@@ -30,5 +30,5 @@
   public class SingleGroupingMove : MultiComponentVectorMove {
     [Storable]
-    public int ItemIndex { get; protected set; }
+    public int Index { get; protected set; }
     [Storable]
     public int NewGroup { get; protected set; }
@@ -38,10 +38,10 @@
     protected SingleGroupingMove(SingleGroupingMove original, Cloner cloner)
       : base(original, cloner) {
-      this.ItemIndex = original.ItemIndex;
+      this.Index = original.Index;
       this.NewGroup = original.NewGroup;
     }
     public SingleGroupingMove(int index, int newGroup, MultiComponentVectorEncoding multiComponentVector)
       : base(multiComponentVector) {
-      ItemIndex = index;
+      Index = index;
       NewGroup = newGroup;
     }
@@ -52,11 +52,8 @@
 
     public override MultiComponentVectorEncoding GetVectorAfterMove() {
-      //var result = new MultiComponentVectorEncoding();
-      //result.PackingInformations = new ItemList<PackingInformation>(this.MultiComponentVector.PackingInformations);
-      //result.PackingInformations[ItemIndex].AssignedBin = NewGroup;
-      //return result;
-      return InsertItemgeneAfterLastItemgeneOfUsedBin(MultiComponentVector, ItemIndex, NewGroup);
+      return GetVectorAfterMove(MultiComponentVector, Index, NewGroup);
     }
-    private MultiComponentVectorEncoding InsertItemgeneAfterLastItemgeneOfUsedBin(MultiComponentVectorEncoding solution, int itemIndex, int binNr) {
+    public static MultiComponentVectorEncoding GetVectorAfterMove(MultiComponentVectorEncoding originalSolution, int itemIndex, int binNr) {
+      var solution = originalSolution.Clone (new Cloner()) as MultiComponentVectorEncoding;
       var itemgene = solution.PackingInformations[itemIndex];
       solution.PackingInformations.Remove(itemgene);
@@ -64,4 +61,5 @@
       int targetIndex = solution.PackingInformations.FindLastIndex(pi => pi.AssignedBin == binNr);
       solution.PackingInformations.Insert(targetIndex + 1, itemgene);
+      //solution.PackingInformations[itemIndex].AssignedBin = binNr;
       return solution;
     }
@@ -70,4 +68,8 @@
       return typeof(SingleGroupingMoveAttribute);
     }
+
+    public override string ToString() {
+      return "GM(i="+Index+",g="+NewGroup+")";
+    }
   }
 }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/SingleItemRotationMove.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/SingleItemRotationMove.cs	(revision 9472)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/SingleItemRotationMove.cs	(revision 9473)
@@ -48,7 +48,9 @@
 
     public override MultiComponentVectorEncoding GetVectorAfterMove() {
-      var result = new MultiComponentVectorEncoding();
-      result.PackingInformations = new ItemList<PackingInformation>(this.MultiComponentVector.PackingInformations);
-      result.PackingInformations[ItemIndex].Rotated = !result.PackingInformations[ItemIndex].Rotated;
+      return GetVectorAfterMove (MultiComponentVector, ItemIndex);
+    }
+    public static MultiComponentVectorEncoding GetVectorAfterMove(MultiComponentVectorEncoding multiComponentVector, int itemIndex) {
+      var result = multiComponentVector.Clone(new Cloner()) as MultiComponentVectorEncoding;
+      result.PackingInformations[itemIndex].Rotated = !result.PackingInformations[itemIndex].Rotated;
       return result;
     }
@@ -57,4 +59,8 @@
       return typeof(SingleItemRotationMoveAttribute);
     }
+
+    public override string ToString() {
+      return "RM(i=" + ItemIndex+")";
+    }
   }
 }
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/SwapPositionMove.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/SwapPositionMove.cs	(revision 9473)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/Moves/SwapPositionMove.cs	(revision 9473)
@@ -0,0 +1,72 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2012 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using HeuristicLab.Common;
+using HeuristicLab.Core;
+using HeuristicLab.Encodings.PackingEncoding.MultiComponentVector;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+
+namespace HeuristicLab.Encodings.PackingEncoding.MultiComponentVector {
+  [Item("SwapPositionMove", "A move on a multi component vector that is specified by two indexes. The packing informations at the speciefied indexes are beeing swapped.")]
+  [StorableClass]
+  public class SwapPositionMove : MultiComponentVectorMove {
+    [Storable]
+    public int Index1 { get; protected set; }
+    [Storable]
+    public int Index2 { get; protected set; }
+
+    [StorableConstructor]
+    protected SwapPositionMove(bool deserializing) : base(deserializing) { }
+    protected SwapPositionMove(SwapPositionMove original, Cloner cloner)
+      : base(original, cloner) {
+      this.Index1 = original.Index1;
+      this.Index2 = original.Index2;
+    }
+    public SwapPositionMove(int index1, int index2, MultiComponentVectorEncoding multiComponentVector)
+      : base(multiComponentVector) {
+        Index1 = index1;
+        Index2 = index2;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      return new SwapPositionMove(this, cloner);
+    }
+
+    public override MultiComponentVectorEncoding GetVectorAfterMove() {
+      return GetVectorAfterMove(MultiComponentVector, Index1, Index2);
+    }
+    public static MultiComponentVectorEncoding GetVectorAfterMove(MultiComponentVectorEncoding multiComponentVector, int index1, int index2) {
+      var result = multiComponentVector.Clone(new Cloner()) as MultiComponentVectorEncoding;
+      var aux = result.PackingInformations[index1];
+      result.PackingInformations[index1] = result.PackingInformations[index2];
+      result.PackingInformations[index2] = aux;
+      return result;
+    }
+
+    public override System.Type GetMoveAttributeType() {
+      return typeof(SwapPositionMoveAttribute);
+    }
+
+    public override string ToString() {
+      return "SM(i1=" + Index1 + ",i2=" + Index2 + ")";
+    }
+  }
+}
Index: /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorMoveGenerator.cs
===================================================================
--- /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorMoveGenerator.cs	(revision 9472)
+++ /branches/HeuristicLab.BinPacking/HeuristicLab.Problems.BinPacking/3.3/Encodings/MultiComponentVector/Moves/ThreeWay/MultiComponentVectorMoveGenerator.cs	(revision 9473)
@@ -27,5 +27,8 @@
 using HeuristicLab.Parameters;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Problems.BinPacking.Decoders;
 using HeuristicLab.Problems.BinPacking.Interfaces;
+using HeuristicLab.Problems.BinPacking.PackingBin;
+using HeuristicLab.Problems.BinPacking.PackingItem;
 
 namespace HeuristicLab.Encodings.PackingEncoding.MultiComponentVector {
@@ -44,5 +47,6 @@
     protected ScopeParameter CurrentScopeParameter {
       get { return (ScopeParameter)Parameters["CurrentScope"]; }
-    }
+    }               
+
 
     [StorableConstructor]
@@ -57,6 +61,7 @@
 
 
-
-
+    public static int NrOfRotationMoves(MultiComponentVectorEncoding mcv) {
+      return mcv.PackingInformations.Count;
+    }
     public static IEnumerable<MultiComponentVectorMove> GenerateRotationMoves(MultiComponentVectorEncoding multiComponentVector) {
       for (int i = 0; i < multiComponentVector.PackingInformations.Count; i++)
@@ -64,4 +69,13 @@
     }
 
+    public static int NrOfSingleGroupingMoves(MultiComponentVectorEncoding mcv) {
+      int nrOfBins = 0;
+      foreach (var pi in mcv.PackingInformations) {
+        if (pi.AssignedBin > nrOfBins)
+          nrOfBins = pi.AssignedBin;
+      }
+      nrOfBins++;
+      return mcv.PackingInformations.Count * (nrOfBins - 1);
+    }
     public static IEnumerable<MultiComponentVectorMove> GenerateSingleGroupingMoves(MultiComponentVectorEncoding multiComponentVector) {
       int nrOfBins = 0;
@@ -78,5 +92,22 @@
     }
 
-    public static IEnumerable<MultiComponentVectorMove> GenerateSwapSequenceMoves(MultiComponentVectorEncoding multiComponentVector) {
+    public static int NrOfSwapPositionMoves(MultiComponentVectorEncoding mcv) {
+      int nrOfBins = 0;
+      foreach (var pi in mcv.PackingInformations) {
+        if (pi.AssignedBin > nrOfBins)
+          nrOfBins = pi.AssignedBin;
+      }
+      nrOfBins++;
+      int[] itemsPerBin = new int[nrOfBins];
+      foreach (var pi in mcv.PackingInformations) {
+        itemsPerBin[pi.AssignedBin]++;
+      }
+      int nrOfSwapPositionMoves = 0;
+      foreach (int items in itemsPerBin) {
+        nrOfSwapPositionMoves += (items * (items - 1)) / 2;
+      }
+      return nrOfSwapPositionMoves;
+    }
+    public static IEnumerable<MultiComponentVectorMove> GenerateSwapPositionMoves(MultiComponentVectorEncoding multiComponentVector) {
       Dictionary<int, List<int>> indexesPerBin = new Dictionary<int, List<int>>();
       for (int i = 0; i < multiComponentVector.PackingInformations.Count; i++) {
@@ -89,8 +120,39 @@
         for (int i = 0; i < entry.Value.Count - 1; i++)
           for (int j = i + 1; j < entry.Value.Count; j++)
-            yield return new SwapSequenceMove(entry.Value[i], entry.Value[j], multiComponentVector);
+            yield return new SwapPositionMove(entry.Value[i], entry.Value[j], multiComponentVector);
       }
     }
 
+    public static int NrOfChangePositionMoves(MultiComponentVectorEncoding mcv) {
+      int nrOfBins = 0;
+      foreach (var pi in mcv.PackingInformations) {
+        if (pi.AssignedBin > nrOfBins)
+          nrOfBins = pi.AssignedBin;
+      }
+      nrOfBins++;
+      int[] itemsPerBin = new int[nrOfBins];
+      foreach (var pi in mcv.PackingInformations) {
+        itemsPerBin[pi.AssignedBin]++;
+      }
+      int nrOfSwapPositionMoves = 0;
+      foreach (int items in itemsPerBin) {
+        nrOfSwapPositionMoves += (items * (items - 1)) / 2;
+      }
+      return nrOfSwapPositionMoves;
+    }
+    public static IEnumerable<MultiComponentVectorMove> GenerateChangePositionMoves(MultiComponentVectorEncoding multiComponentVector) {
+      Dictionary<int, List<int>> indexesPerBin = new Dictionary<int, List<int>>();
+      for (int i = 0; i < multiComponentVector.PackingInformations.Count; i++) {
+        int currentBin = multiComponentVector.PackingInformations[i].AssignedBin;
+        if (!indexesPerBin.ContainsKey(currentBin))
+          indexesPerBin[currentBin] = new List<int>();
+        indexesPerBin[currentBin].Add(i);
+      }
+      foreach (var entry in indexesPerBin) {
+        for (int i = 0; i < entry.Value.Count - 1; i++)
+          for (int j = i + 1; j < entry.Value.Count; j++)
+            yield return new ChangePositionMove(entry.Value[i], entry.Value[j], multiComponentVector);
+      }
+    }
 
     public override IOperation Apply() {
